﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinSchedule;

namespace UltraTimeLineViewAppoitment
{
    public partial class Form1 : Form
    {
        private DataTable theAppointments;
        private const int randomSeed = 0;
        private Random rnd;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //Dta_Appointments = CreateAppointmentsDataTable();
            //CreateAppointments(Dta_Appointments);


            DataSet ds = new DataSet();

            // Create Appointments DataTable
            theAppointments = new DataTable("Appointments");
            theAppointments.Columns.Add("AppointmentID", typeof(int));
            theAppointments.Columns.Add("StartTime", typeof(DateTime));
            theAppointments.Columns.Add("EndTime", typeof(DateTime));
            theAppointments.Columns.Add("Subject", typeof(string));
            theAppointments.Columns.Add("OwnerKey", typeof(string));

            // Add Appointments Sample Data
            theAppointments.Rows.Add(new object[] { 1, DateTime.Now, DateTime.Now.AddHours(1), "Test 1", "Owner 1" });
            theAppointments.Rows.Add(new object[] { 1, DateTime.Now.AddHours(1), DateTime.Now.AddHours(4), "Test 2", "Owner 2" });
            theAppointments.Rows.Add(new object[] { 1, DateTime.Now.AddHours(2), DateTime.Now.AddHours(5), "Test 3", "Owner 1" });
            theAppointments.Rows.Add(new object[] { 1, DateTime.Now.AddHours(3), DateTime.Now.AddHours(7), "Test 4", "Owner 2" });

            // Create Owners DataTable
            DataTable theOwners = new DataTable("Owners");
            theOwners.Columns.Add("OwnerID", typeof(int));
            theOwners.Columns.Add("Name", typeof(string));
            theOwners.Columns.Add("OwnerKey", typeof(string));

            // Add Owners Sample Data
            theOwners.Rows.Add(new object[] { 1, "Owner 1", "Owner 1" });
            theOwners.Rows.Add(new object[] { 2, "Owner 2", "Owner 2" });


            ds.Tables.Add(theAppointments);
            ds.Tables.Add(theOwners);


            this.ultraCalendarInfo1.Owners.UnassignedOwner.Visible = false;
            this.ultraCalendarInfo1.DataBindingsForAppointments.DataSource = ds.Tables["Appointments"];
            this.ultraCalendarInfo1.DataBindingsForOwners.DataSource = ds.Tables["Owners"];

            // Set Appointments data binding properties to UltraCalendarInfo
            this.ultraCalendarInfo1.DataBindingsForAppointments.StartDateTimeMember = "StartTime";

            this.ultraCalendarInfo1.DataBindingsForAppointments.EndDateTimeMember = "EndTime";

            this.ultraCalendarInfo1.DataBindingsForAppointments.SubjectMember = "Subject";
            this.ultraCalendarInfo1.DataBindingsForAppointments.OwnerKeyMember = "OwnerKey";

            // Set Owners data binding properties to UltraCalendarInfo
            this.ultraCalendarInfo1.DataBindingsForOwners.KeyMember = "OwnerKey";
            this.ultraCalendarInfo1.DataBindingsForOwners.NameMember = "Name";

            // Assign CalendarInfo component to TimelineView control
            ultraTimelineView1.CalendarInfo = this.ultraCalendarInfo1;


            return;




            //DataTable newTable = new DataTable("AA");
            //newTable.Columns.Add("Subject", typeof(string));
            //newTable.Columns.Add("StartDateTime", typeof(DateTime));
            //newTable.Columns.Add("EndDateTime", typeof(DateTime));
            //newTable.Columns.Add("Description", typeof(String));

            //newTable.Columns.Add("AllDayEvent", typeof(bool));
            //newTable.Columns.Add("ReminderEnabled", typeof(bool));
            //newTable.Columns.Add("ReminderInterval", typeof(int));
            //newTable.Columns.Add("ReminderUnits", typeof(int));
            //newTable.Columns.Add("OwnerKey", typeof(string));
            //newTable.Columns.Add("RecurrenceId", typeof(System.Guid));
            //newTable.Columns.Add("Recurrence", typeof(Byte[]));
            //newTable.Columns.Add("OriginalStartDateTime", typeof(DateTime));
            //newTable.Columns.Add("DataKey", typeof(string));
            //newTable.Columns.Add("AllProperties", typeof(Byte[]));


            //newTable.Rows.Add("ALALA", DateTime.Now, DateTime.Now, "aaaaa", false, false, 15, 1, "Owner", null,null , DateTime.Now, "Key 1",null);


            //ultraCalendarInfo1.Owners.Add("Owner");

            //ultraCalendarInfo1.DataBindingsForAppointments.BindingContextControl = this;
            //ultraCalendarInfo1.DataBindingsForAppointments.DataSource = Dta_Appointments;
            // ultraCalendarInfo1.DataBindingsForAppointments.SetDataBinding(newTable, "AA");



            //ultraCalendarInfo1.DataBindingsForAppointments.SetDataBinding(Dta_Appointments, "Appointments");


            // Basic Appointment properties
            //ultraCalendarInfo1.DataBindingsForAppointments.SubjectMember = "Subject";
            //ultraCalendarInfo1.DataBindingsForAppointments.DescriptionMember = "Description";

            //ultraCalendarInfo1.DataBindingsForAppointments.StartDateTimeMember = "StartDateTime";
            //ultraCalendarInfo1.DataBindingsForAppointments.EndDateTimeMember = "EndDateTime";
            //ultraCalendarInfo1.DataBindingsForAppointments.AllDayEventMember = "AllDayEvent";

            //ultraCalendarInfo1.DataBindingsForAppointments.ReminderEnabledMember = "ReminderEnabled";
            //ultraCalendarInfo1.DataBindingsForAppointments.ReminderIntervalMember = "ReminderInterval";
            //ultraCalendarInfo1.DataBindingsForAppointments.ReminderUnitsMember = "ReminderUnits";
            //ultraCalendarInfo1.DataBindingsForAppointments.OwnerKeyMember = "OwnerKey";
            //ultraCalendarInfo1.DataBindingsForAppointments.RecurrenceIdMember = "RecurrenceId";
            //ultraCalendarInfo1.DataBindingsForAppointments.DataKeyMember = "DataKey";
            //ultraCalendarInfo1.DataBindingsForAppointments.OriginalStartDateTimeMember = "OriginalStartDateTime";
            //ultraCalendarInfo1.DataBindingsForAppointments.RecurrenceMember = "Recurrence";
            //ultraCalendarInfo1.DataBindingsForAppointments.RefreshData();
            //this.ultraTimelineView1.CalendarInfo = ultraCalendarInfo1;
            //this.ultraTimelineView1.ow CalendarInfo.Owners = this.ultraTimelineView1.CalendarInfo.Owners[1];

        }

        private DataTable CreateAppointmentsDataTable()
        {
            DataTable newTable = new DataTable();

            //Basic Appointment properties
            //In order to function properly, the table must contain data for 
            //Subject, StartDateTime, and EndDateTime. These three fields are 
            //required for an appointment. So all of these will have DefaultValues.
            newTable.Columns.Add("Subject", typeof(string));
            newTable.Columns["Subject"].DefaultValue = "New Appointment";
            newTable.Columns.Add("StartDateTime", typeof(DateTime));
            newTable.Columns["StartDateTime"].DefaultValue = DateTime.Now;
            newTable.Columns.Add("EndDateTime", typeof(DateTime));
            newTable.Columns["EndDateTime"].DefaultValue = DateTime.Now.AddHours(1);
            newTable.Columns.Add("Description", typeof(String));

            // All other fields are Optional.

            //Properties for AllDayEvents
            newTable.Columns.Add("AllDayEvent", typeof(Boolean));
            newTable.Columns["AllDayEvent"].DefaultValue = false;

            //Properties for Reminders
            newTable.Columns.Add("ReminderEnabled", typeof(bool));
            newTable.Columns["ReminderEnabled"].DefaultValue = false;
            newTable.Columns.Add("ReminderInterval", typeof(int));
            newTable.Columns.Add("ReminderUnits", typeof(int));

            //Properties when using owners
            newTable.Columns.Add("OwnerKey", typeof(string));

            //Properties when using recurring appointments. 
            newTable.Columns.Add("RecurrenceId", typeof(System.Guid));
            newTable.Columns.Add("Recurrence", typeof(Byte[]));
            newTable.Columns.Add("OriginalStartDateTime", typeof(DateTime));

            //DataKey is an extra field that can be used to link the appointment to some external data. 
            newTable.Columns.Add("DataKey", typeof(string));

            //All properties    
            //Any other Appointment properties not covered above are stored as 
            //Binary data in the AllProperties field. This includes properties like 
            //BarColor, Location, etc. 
            newTable.Columns.Add("AllProperties", typeof(Byte[]));
            return newTable;


        }
    }

}



